// Fill out your copyright notice in the Description page of Project Settings.


#include "Player/LMPlayer.h"

#include "Camera/CameraComponent.h"
#include "Weapon/LMWeaponManager.h"

ALMPlayer::ALMPlayer()
{
	PrimaryActorTick.bCanEverTick = true;

	Camera = CreateDefaultSubobject<UCameraComponent>(TEXT("Camera"));
	Camera->SetupAttachment(RootComponent);
	Camera->bUsePawnControlRotation = true;
	Camera->SetRelativeLocation(FVector(20, 0, 90));
	
	WeaponSkeletalMeshComponent = CreateDefaultSubobject<USkeletalMeshComponent>(TEXT("Weapon Mesh"));
	WeaponSkeletalMeshComponent->SetupAttachment(Camera);
}

void ALMPlayer::BeginPlay()
{
	Super::BeginPlay();
}

void ALMPlayer::SetWeaponManager(ULMWeaponManager* Manager)
{
	UE_LOG(LogTemp, Warning, TEXT("Set weapon manager"))
	if (!Manager)
	{
		GEngine->AddOnScreenDebugMessage(INDEX_NONE, 10.f, FColor::Red, TEXT("No Weapon Manager was given to the player !"));
		return;
	}
	
	WeaponManager = Manager;
	WeaponManager->Initialize(WeaponSkeletalMeshComponent);
}

void ALMPlayer::Tick(float DeltaTime)
{
	Super::Tick(DeltaTime);
}

void ALMPlayer::SetupPlayerInputComponent(UInputComponent* PlayerInputComponent)
{
	Super::SetupPlayerInputComponent(PlayerInputComponent);
}

